<h2>{{ userName }}'s Contacts</h2>
@if (msg) {
  <div class="msg">{{ msg }}</div>
}

@if (contact) {
  <form (ngSubmit)="onSubmit()" [formGroup]="contactForm">
    <h3 appHighlight>{{ contact.name | awesome }}</h3>
    <div class="form-group">
      <label for="name">Name</label>
      <input type="text" [formControl]="contactForm.controls.name" />
      @if (contactForm.controls.name.hasError('required') && contactForm.controls.name.touched) {
        <div class="alert"> Name is required. </div>
      }
      @if (contactForm.controls.name.hasError('nameExists') && contactForm.controls.name.touched) {
        <div class="alert"> Name already exists. </div>
      }
      <label for="name">Age</label>
      <input type="number" [formControl]="contactForm.controls.age" />
      @if (contactForm.controls.age.getError('required') && contactForm.controls.age.touched) {
        <div class="alert"> Age is required. </div>
      }
      @if (contactForm.controls.age.getError('min') && contactForm.controls.age.touched) {
        <div class="alert"> Minimun age is 18 </div>
      }
      @if (contactForm.controls.age.getError('max') && contactForm.controls.age.touched) {
        <div class="alert"> Max age is 65 </div>
      }

      <label for="name">Birthdate</label>
      <input type="date" [formControl]="contactForm.controls.birthDate" />
      @if (
        contactForm.controls.birthDate.hasError('invalidDate') &&
        contactForm.controls.birthDate.touched
      ) {
        <div class="alert"> Birthdate is invalid. </div>
      }
      @if (contactForm.hasError('ageInvalid') && contactForm.controls.birthDate.touched) {
        <div class="alert"> Age and birthdate don't match. </div>
      }
    </div>
    <div class="button-group">
      <button type="submit" class="btn btn-default" [disabled]="!contactForm.valid"> Save</button>
      <button
        type="button"
        class="btn"
        (click)="next()"
        [disabled]="!contactForm.valid && contactForm.touched"
      >
        Next Contact</button
      >
      <button type="button" class="btn" (click)="newContact()"> New Contact</button>
      <button type="button" class="btn" (click)="showFormValues()">Show values</button>
    </div>
  </form>
}
